#include <string>
#include <vector>
#include <cmath>
#include <cctype>
#include <queue>
#include <map>
#include <set>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <utility>
#include <numeric>
#include <complex>

using namespace std;

vector <int> bx, by, qx, qy, ax, ay;
int dist[300][300];
bool bvisit[300];
int B, Q, A;

int d(int x1, int y1, int x2, int y2)
{
  return (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2);
}

bool visited[300]; 

void dfs(int k, int dd)
{
  if (visited[k]) return;
  visited[k] = true;
  if (k < B)
  {
    bvisit[k] = true;
    for (int i = 0; i < A; i++)
    if (!visited[i] && dist[k][i] <= dd)
       dfs(i, dd);
  }
}

bool ok(int j, int dd)
{
  for (int i = 0; i < A; i++)
    visited[i] = false;
  dfs(j, dd);
  for (int i = B; i < A; i++)
    if (!visited[i]) return false;
  return true;
}

double chooseBomb(vector <string> field) 

{
  bx.clear();
  by.clear();
  qx.clear();
  qy.clear();
  ax.clear();
  ay.clear();


  for (int i = 0; i < field.size(); i++)
    for (int j = 0; j < field[i].length(); j++)
    {
      if (field[i][j] == '*')
      {
        bx.push_back(i);
        by.push_back(j);
      }
      else if (field[i][j] == '?')
           {
             qx.push_back(i);
             qy.push_back(j);
           }
    }
    ax = bx; ay = by;
    ax.insert(ax.end(), qx.begin(), qx.end());
    ay.insert(ay.end(), qy.begin(), qy.end());
    B = bx.size(); Q = qx.size(); A = B+Q;


    for (int i = 0; i < A; i++)
      for (int j = 0; j < A; j++)
         dist[i][j] = d(ax[i], ay[i], ax[j], ay[j]);


    set <int> sq;
    for (int i = 0; i <= 50; i++)
      for (int j = 0; j <= 50; j++)
        sq.insert(i*i + j*j);
    

    vector <int> v(sq.begin(), sq.end());
    for (int i = 0; i < v.size(); i++)
    {
      for (int j = 0; j < B; j++)
      bvisit[j] = false;
      bool good = true;
      for (int j = 0; j < B; j++)
        if (!bvisit[j])
        {
          if (!ok(j, v[i]))
          {
            good = false;
            break;
          }
        }
      if (good) return sqrt((double) v[i]);
    }
    return -1;
}

int main()
{
  while(1)
  { 

    int n,m;
    cin>>n>>m;
    if(n==0 || m==0) break;
    vector<string> field(n);
    

    for(int i=0;i<n;++i)
    cin>>field[i];
    cout.precision(10);
    cout<<chooseBomb(field)<<endl;
  }
  return 0;
}
